<?php

class FLIRTYREF_CLASS_EventHandler {

    public function __construct() {
        
    }

    public function onUserRegister(OW_Event $event) {
        $params = $event->getParams();
        $invitationCode = $params['params']['code'];

        if (empty($invitationCode)) {
            return;
        }

        $lang = OW::getLanguage();
        $userService = BOL_UserService::getInstance();

        $userId = !empty($params['userId']) ? (int) $params['userId'] : OW::getUser()->getId();
        $userName = $userService->getDisplayName($userId);
        $userUrl = $userService->getUserUrl($userId);

        $invitation = $userService->findInvitationInfo($invitationCode);

        if ( $invitation === null){
           return;
        }
        
        if ( $invitation->userId == 0 ) {
           return;
        }
                
        $inviterUser = $invitation->userId;
        $inviterName = $userService->getDisplayName($inviterUser);

        $mail = OW::getMailer()->createMail();
        $mail->addRecipientEmail($userService->findUserById($inviterUser)->getEmail());
        $mail->setSubject($lang->text('flirtyref', 'mail_template_subject', array('inviterName' => $inviterName, 'userUrl' => $userUrl, 'userName' => $userName)));
        $mail->setHtmlContent($lang->text('flirtyref', 'mail_template_content_html', array('inviterName' => $inviterName, 'userUrl' => $userUrl, 'userName' => $userName)));
        $mail->setTextContent($lang->text('flirtyref', 'mail_template_content_text', array('inviterName' => $inviterName, 'userUrl' => $userUrl, 'userName' => $userName)));

        OW::getMailer()->addToQueue($mail);

        $eventParams = array('pluginKey' => 'flirtyref', 'action' => 'friend_joined', 'userId' => $inviterUser);

        if (OW::getEventManager()->call('usercredits.check_balance', $eventParams) === true) {
            OW::getEventManager()->call('usercredits.track_action', $eventParams);
        }
    }

}
